\chapter{Introduction}
Today, there are various challenges to traditional centralized learning practices. As an immense amount of data is generated constantly and rapidly at different locations, centralized systems have significant scalability limitations. Also, the data being located only in one place, being collected from different resources, or being moved to other sites increases doubts about its privacy and security. However, decentralized learning techniques can elevate these problems. A decentralized approach is much more natural in recommender systems or systems where data is linked to a user. Here, the security and privacy concerns are solved by allowing only the owner of sensitive data to access it and perform further modifications. Furthermore, the data is distributed in multiple locations, allowing for faster processing, a more scalable system, and better handling of highly distributed or imbalanced data.
\\

In decentralized machine learning, the distributed nodes have models trained only on local datasets. Besides local training, the models are improved by exchanging model parameters, such as weights and biases, with their neighbors and updating their own model. In that way, nodes are gradually improving their model and, therefore, the models of their neighbors. This machine learning approach enables the creation of a robust and scalable model without sharing data, thus addressing the critical issue of data privacy. However, sharing model parameters increases network traffic since models are usually large, and combining neighboring models with local ones increases the time and requires more computations. Hence, new questions about which model parameters should be shared, what should be the fraction of the model, with whom, and how to do the local model updates require additional research.
\\

This report addresses previously mentioned issues with decentralized machine learning systems and researches the system's performances using different communication and model sharing techniques. We vary the communication of a node with all its neighbors or with a randomly chosen one, alternating how to update the local model. Furthermore, the selection of model parameters varies, such as choosing the ones that changed the most. The goal is to analyze the system's performance in terms of model accuracy, network traffic loads, and total processing time. In order to examine, two different machine learning models are used on three different datasets, covering both recommendation and classification models. 
\\

Firstly, in Chapter \ref{background}, we explain two machine learning models used, one for recommendation and the other for classification, and give a brief overview of decentralized learning. Then, in Chapter \ref{implementation}, we present how all components are connected and together make the decentralized system. Additionally, we explain two different techniques for exchanging information in the network and the corresponding local model updates. Here, the details of various sharing methods are also depicted, as well as an explanation for configuring the system. Next, Chapter \ref{evaluation} covers datasets, together with metrics used for system evaluation and test environment specifics. Furthermore, various experiments are presented to understand the performance of different communication and model sharing techniques. This report is ended by providing a conclusion and future work in Chapter \ref{conclusion}.